# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, k) = map(int, fi.readline().split())
if 1 > n or n > 100000:
	sys.exit('N out of range')
if 1 > k or k > 100000:
	sys.exit('K out of range')
fo.write('{0} {1}\n'.format(n, k))

a = {}
for i in range(k):
	(l, r) = map(int, fi.readline().split())
	if 1 > l or l > r:
		sys.exit('L[{0}] out of range'.format(1 + i))
	if l > r or r > n:
		sys.exit('R[{0}] out of range'.format(1 + i))
	fo.write('{0} {1}\n'.format(l, r))
	r += 1
	a[l] = (a[l] if l in a else 0) + 1
	a[r] = (a[r] if r in a else 0) - 1

if 1 not in a:
	sys.exit('No attendance on week 1')
m = 0
for i in sorted(a):
	m += a[i]
	if i <= n and m == 0:
		sys.exit('No attendance on week {0}'.format(i))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 100 and k <= 100:
		print('subtask 1')
	elif n <= 10000 and k <= 10000:
		print('subtask 2')
	else:
		print('subtask 3')
