from heapq import *

fin = open("klubisis.txt", 'r')
t = [ line.split() for line in fin.read().split('\n') if line ]
fin.close()

freetasks = []
takentasks = []

weeks = []

n = int(t[0][0])
k = int(t[0][1])
ls = []
rs = []
liitujad = []

for line in t[1:]:
    ls.append(int(line[0]))
    rs.append(int(line[1]))

for i in range(k):
    liitujad.append((ls[i], i))

liitujad.sort()

for i in range(1,100001):
    heappush(freetasks, i)

liitujaindeks = 0
hiliseim_liige = 0
for i in range(1,n+1):
    while takentasks != []:
        nexttaken = heappop(takentasks)
        if (nexttaken[0] < i):
            heappush(freetasks, nexttaken[1])
        else:
            heappush(takentasks, nexttaken)
            break
    
    weeks.append(heappop(freetasks))
    
    while liitujaindeks < k:
        liituja = liitujad[liitujaindeks]
        if liituja[0] < i:
            assert(False)
        elif liituja[0] == i:
            liitujaindeks += 1
            if hiliseim_liige < rs[liituja[1]]:
                hiliseim_liige = rs[liituja[1]]
        else:
            break
    
    heappush(takentasks, (hiliseim_liige, weeks[-1]))

fout = open("klubival.txt", 'w')
for w in weeks:
    fout.write(str(w)+'\n')
fout.close()
