# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline().strip())
if 1 > n or n > 100000:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

xx = []
yy = []
zz = set()
for i in range(n):
	(x, y) = map(int, fi.readline().split())
	if -1e8 > x or x > 1e8:
		sys.exit('X[{0}] out of range'.format(1 + i))
	if -1e8 > y or y > 1e8:
		sys.exit('Y[{0}] out of range'.format(1 + i))
	fo.write('{0} {1}\n'.format(x, y))
	xx.append(x)
	yy.append(y)
	zz.add((x, y))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 20 and min(xx) >= -1000 and max(xx) <= 1000 and min(yy) >= -1000 and max(yy) <= 1000:
		print('subtask 1')
	elif n <= 1000:
		print('subtask 2')
	else:
		print('subtask 3')
	if len(zz) != n:
		print('{1} -> {2}\n'.format(n, len(zz)))
