#!/bin/sh -e

input=$(mktemp)
output0=$(mktemp)
output1=$(mktemp)

cleanup() {
	rm -f "$input"
	rm -f "$output0"
	rm -f "$output1"
}
trap cleanup EXIT

prog0=$1
shift
prog1=$1
shift

while true
do
	python3 ./gen/gen.py "$@" > "$input"
	cat "$input" | eval "$prog0" > "$output0"
	cat "$input" | eval "$prog1" > "$output1"
	cat "$output0" "$output1" | python3 sol/check.py >&2 || (
		cat "$input"
		exit 1
	) || exit 0
	printf . >&2
done
