#include <iostream>
#include <fstream>
#include <cstdlib>
#include <vector>
#include <algorithm>
using namespace std;

ofstream fi("summasis.txt");
ofstream fo("summaval.txt");

int main(int argc, const char *argv[]) {
	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	srand(n + m);
	vector<int> f(1 + m, 1);
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		int x = rand() % (m - i + 1), j = 0;
		for ( ; ; ) {
			x -= f[j];
			if (x == -1) {
				break;
			} else {
				++j;
			}
		}
		f[j] = 0;
		a[i] = j;
	}
	sort(a.begin(), a.end());
	vector<int> p(2 * m, 0);
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			++p[a[i] + a[j]];
		}
	}
	int s = 0, sm = 0;
	for (int i = 0; i < 2 * m; ++i) {
		if (sm < p[i]) {
			sm = p[i];
			s = i;
		}
	}
	fi << n << ' ' << s << '\n';
	for (int i = 0; i < n; ++i) {
		fi << a[i] << '\n';
	}
	fo << sm << '\n';
	cout << s << ' ' << sm << '\n';
	return 0;
}
