// Üsna efektiivne lahendus kahendotsinguga

#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

ifstream fi("summasis.txt");
ofstream fo("summaval.txt");

int main() {
	// Loeme sisendi
	int n, s;
	fi >> n >> s;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		fi >> a[i];
	}

	// Otsime jada igale elemendile sobivat paarilist kahendotsinguga
	int c = 0;
	for (int i = 0; i < n; ++i) {
		int j = lower_bound(a.begin(), a.end(), s - a[i]) - a.begin();
		if (i < j && j < n && a[i] + a[j] == s) {
			++c;
		}
	}

	// Väljastame vastuse
	fo << c << '\n';
	return 0;
}
