// Ülesande laiendatud versiooni lahendus:
// - ei eelda, et sisend on sorteeritud,
// - ei eelda, et elemendid on unikaalsed.

#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

ifstream fi("summasis.txt");
ofstream fo("summaval.txt");

int main() {
	// Loeme sisendi
	int n, s;
	fi >> n >> s;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		fi >> a[i];
	}

	// Unikaalsed väärtused ja nende esinemissagedused
	sort(a.begin(), a.end());
	vector<long long> b(n);
	int m = 0;
	b[m] = 1;
	for (int i = 1; i < n; ++i) {
		if (a[i] == a[m]) {
			++b[m];
		} else {
			++m;
			a[m] = a[i];
			b[m] = 1;
		}
	}

	// Loendame sobivad paarid
	long long c = 0;
	int i = 0, j = m;
	while (i < j) {
		if (a[i] + a[j] < s) {
			++i;
			continue;
		}
		if (a[i] + a[j] > s) {
			--j;
			continue;
		}
		// Siin alati a[i] + a[j] == s
		c += b[i] * b[j];
		++i; --j;
	}
	if (2 * a[i] == s) {
		c += b[i] * (b[i] - 1) / 2;
	}

	// Väljastame vastuse
	fo << c << '\n';
	return 0;
}
