#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define P(A,B,C) if (x A y B z C w) { ++n; sprintf(s, "%d%c%d%c%d%c%d", x, #A[0], y, #B[0], z, #C[0], w); if (!strcmp(s, sol)) answer(1, "OK"); }
#define X(A,B) P(A,==,B) P(==,A,B) P(A,B,==)
#define Z(A) X(A,+) X(A,-) X(A,*)

void answer(int p, char *s) {
	printf("%d\n", p);
	fprintf(stderr,"%s\n", s);
	exit(0);
}

int main(int argc, char **argv) {
	FILE *infile, *outfile, *solfile;
	int x, y, z, w;
	char c;
	char sol[200];
	char s[200];
	int n = 0;

	infile = fopen(argv[1], "rt");
	outfile = fopen(argv[2], "rt");
	solfile = fopen(argv[3],"rt");

	if (solfile == NULL)
		answer(0, "No output file");

	if (fgets(sol, 100, solfile) == NULL) 
		answer(0, "Empty output file");

	// strip trailing whitespaces 
	char *end = sol + strlen(sol) - 1;
	while (end >= sol && isspace((unsigned char) *end)) end--;
	end[1] = '\0';

	fscanf(infile, "%d%c%d%c%d%c%d", &x, &c, &y, &c, &z, &c, &w);

	do {
		Z(+)
		Z(-)
		Z(*)
		if (n == 0 && !strcmp(sol, "EI SAA")) 
			answer(1, "OK");
		else 
			answer(0, "Wrong answer");
	} while(0);
	return 0;
}
