#include <stdio.h>
#include <stdlib.h>
#include <math.h>

const double eps = 1e-6;

void done(int n, const char *s) {
	fprintf(stdout, "%d\n", n);
	fprintf(stderr, "%s\n", s);
	exit(0);
}

int main (int argc, const char *argv[]) {
	//FILE *fi = fopen(argv[1], "rt");
	FILE *fh = fopen(argv[2], "rt");
	FILE *fo = fopen(argv[3], "rt");
	double ah, ao;

	fscanf(fh, "%lf", &ah);

	if (fo == NULL) {
		done(0, "No output file");
	}
	if (fscanf(fo, "%lf", &ao) != 1) {
		done(0, "Wrong format");
	}
	if (!isfinite(ao) || fabs(ao - ah) > eps * ah) {
		done(0, "Wrong answer");
	}
	done(1, "OK");
}
