// Efektiivne lahendus inkrementaalse lineaarse otsinguga

#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

ifstream fi("summasis.txt");
ofstream fo("summaval.txt");

int main() {
	// Loeme sisendi
	int n, s;
	fi >> n >> s;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		fi >> a[i];
	}

	// Otsime jada igale elemendile sobivat paarilist lineaarse otsinguga,
	// aga alustame iga uut otsingut sealt, kus eelmine lõppes
	int c = 0;
	int j = n - 1;
	for (int i = 0; i < n; ++i) {
		while (i < j && a[i] + a[j] > s) {
			--j;
		}
		if (i < j && a[i] + a[j] == s) {
			++c;
		}
	}

	// Väljastame vastuse
	fo << c << '\n';
	return 0;
}
