# -- coding: utf-8 --

# Ülesande laiendatud versiooni lahendus:
# - ei eelda, et sisend on sorteeritud,
# - ei eelda, et elemendid on unikaalsed.

fi = open('summasis.txt', 'rt');
fo = open('summaval.txt', 'wt');

# Loeme sisendi
(n, s) = [int(x) for x in fi.readline().split()]
a = [int(x) for x in fi.readlines()]

# Unikaalsed väärtused ja nende esinemissagedused
a.sort()
b = [1]
m = 0
for i in range(1, n):
	if a[i] == a[m]:
		b[m] += 1
	else:
		m += 1
		a[m] = a[i]
		b.append(1)

# Loendame sobivad paarid
c = 0
i = 0
j = m
while i < j:
	if a[i] + a[j] < s:
		i += 1
		continue
	if a[i] + a[j] > s:
		j -= 1
		continue
	# Siin alati a[i] + a[j] == s
	c += b[i] * b[j]
	i += 1
	j -= 1
if 2 * a[i] == s:
	c += b[i] * (b[i] - 1) / 2

# Väljastame vastuse
fo.write('{0}\n'.format(c))

fi.close()
fo.close()
